Index: sansview/perspectives/fitting/fitpage.py
===================================================================
--- sansview/perspectives/fitting/fitpage.py	(revision e473e4f5a0a9f81b892557da5bbdbba3731c6379)
+++ sansview/perspectives/fitting/fitpage.py	(revision 813334e1ab9133413285c19e0910f0282e30f4e2)
@@ -45,4 +45,5 @@
         ## draw sizer
         self._fill_datainfo_sizer()
+        print "self.qmin, self.qmax====>",self.qmax_x,self.qmin_x
         self._fill_model_sizer( self.sizer1)
         self._fill_range_sizer() 
@@ -53,9 +54,5 @@
                 self.enable_smearer.Disable()
                 self.disable_smearer.Disable()
-        #try:
-            ##Calculate chi2
-        #    self.compute_chisqr(smearer= temp_smearer)  
-        #except:
-        #    raise              
+       
         ## to update the panel according to the fit engine type selected
         self.Bind(EVT_FITTER_TYPE,self._on_engine_change)
@@ -188,41 +185,37 @@
         if not hasattr(self.data,"data"): #Display only for 1D data fit
             # Minimum value of data   
-            #data_min = str(format_number(numpy.min(self.data.x)))
-            data_min = str((numpy.min(self.data.x)))
+            data_min = min(self.data.x)
             # Maximum value of data  
-#            data_max = str(format_number(numpy.max(self.data.x)))
-            data_max = str((numpy.max(self.data.x)))
+            data_max = max(self.data.x)
             text4_3 = wx.StaticText(self, -1, 'Total Q Range (1/A)',
                                      style=wx.ALIGN_LEFT)
             sizer_data.Add( text4_3 )
-            sizer_data.Add(wx.StaticText(self, -1, "Min : %s"%data_min))
-            
-            sizer_data.Add(wx.StaticText(self, -1, "Max : %s"%data_max))
+            sizer_data.Add(wx.StaticText(self, -1, "Min : %s"%str(data_min)))
+            sizer_data.Add(wx.StaticText(self, -1, "Max : %s"%str(data_max)))
             
         else:
-            radius_min= 0
-            x= numpy.max(self.data.xmin, self.data.xmax)
-            y= numpy.max(self.data.ymin, self.data.ymax)
-            radius_max = math.sqrt(x*x + y*y)
-            
+            ## Minimum value of data 
+            data_min= 0
+            x= max(math.fabs(self.data.xmin), math.fabs(self.data.xmax)) 
+            y= max(math.fabs(self.data.ymin), math.fabs(self.data.ymax))
+            ## Maximum value of data  
+            data_max = math.sqrt(x*x + y*y)
+          
             #For qmin and qmax, do not use format_number
             #.(If do, qmin and max could be different from what is in the data.)
-            # Minimum value of data   
-            data_min = str((radius_min))
-            # Maximum value of data  
-            data_max = str((radius_max))
             text4_3 = wx.StaticText(self, -1, "Total Q Range (1/A)",
                                      style=wx.ALIGN_LEFT)
             sizer_data.Add( text4_3 )
-            sizer_data.Add(wx.StaticText(self, -1, "Min : %s"%data_min))
-            sizer_data.Add(wx.StaticText(self, -1, "Max : %s"%data_max))
-            
+            sizer_data.Add(wx.StaticText(self, -1, "Min : %s"%str(data_min)))
+            sizer_data.Add(wx.StaticText(self, -1, "Max : %s"%str(data_max)))
+        ## set q range to plot
+        self.qmin_x= data_min
+        self.qmax_x= data_max
+
         boxsizer1.Add(sizer_data)
         #------------------------------------------------------------
         self.sizer0.Add(boxsizer1,0, wx.EXPAND | wx.ALL, 10)
         self.sizer0.Layout()
-        
-        self.qmin_x= data_min
-        self.qmax_x= data_max
+       
         
        
Index: sansview/perspectives/fitting/fitting.py
===================================================================
--- sansview/perspectives/fitting/fitting.py	(revision 2b63df09a5826d4b448bcf0aa71725f284eab711)
+++ sansview/perspectives/fitting/fitting.py	(revision 813334e1ab9133413285c19e0910f0282e30f4e2)
@@ -635,4 +635,5 @@
                     item.is_data=True
                     data.is_data=True
+                
             ## create anew page                   
             if item.name == self.panel.graph.selected_plottable or\
@@ -649,5 +650,5 @@
                         self.page_finder[page].add_plotted_data(item)
                         self.page_finder[page].add_fit_data(data)
-                        
+
                         wx.PostEvent(self.parent, StatusEvent(status="Page Created"))
                     else:
Index: sansview/perspectives/fitting/model_thread.py
===================================================================
--- sansview/perspectives/fitting/model_thread.py	(revision fb8daaaf9e7ad86469a1ab7d2a82f967ca1ed1ed)
+++ sansview/perspectives/fitting/model_thread.py	(revision 813334e1ab9133413285c19e0910f0282e30f4e2)
@@ -106,7 +106,6 @@
             Compute the data given a model function
         """
-        x = self.x
-        y = self.y
-        output = numpy.zeros((len(x),len(y)))
+     
+        output = numpy.zeros((len(self.x),len(self.y)))
         if self.qmin==None:
             self.qmin = 0
@@ -116,7 +115,6 @@
                 newy= math.pow(max(math.fabs(self.data.ymax),math.fabs(self.data.ymin)),2)
                 self.qmax=math.sqrt( newx + newy )
-            else:
-                self.qmax= max(self.x)
-        
+      
+       
         self.starttime = time.time()
         lx = len(self.x)